﻿using System;
using System.Linq.Expressions;

namespace Brainteasers
{
    class Base
    {
        protected static void Foo(Func<int> func)
        {
            Console.WriteLine("Foo 1");
        }
    }

    class AnonymousFunctions : Base
    {
        static void Main()
        {
            int x = 10;
            Foo(() => x);
            Foo(delegate { return x; });

            Bar(() => x);
            Bar(delegate { return x; });
        }

        static void Foo(Func<int, int> func)
        {
            Console.WriteLine("Foo 2");
        }
        
        static void Bar(Expression<Func<int>> func)
        {
            Console.WriteLine("Bar 1");
        }

        static void Bar(Func<int, int> func)
        {
            Console.WriteLine("Bar 2");
        }

    }
}
